-----------------------
--Author- cogumel0
--v0.1

--Original idea by:
--Motig-VashjEU
-----------------------
local mSpeed = nil;
local updateInterval = 0.1;

local df = CreateFrame("FRAME","TargetMovementDifferencial_DisplayFrame",UIParent);
	df:SetWidth(150); df:SetHeight(20);
	df:SetPoint("CENTER");
	df:SetMovable(true);
	df:SetScript("OnMouseDown", df.StartMoving)
	df:SetScript("OnMouseUp", df.StopMovingOrSizing)
local fs = df:CreateFontString("$parentText","ARTWORK","GameFontNormal");
	fs:SetAllPoints();
	df:Hide();
local tex = df:CreateTexture("ARTWORK");
	tex:SetAllPoints();

function TMD_OnLoad()
	
	TargetMovementDifferencialFrame:RegisterEvent("PLAYER_TARGET_CHANGED");

	SLASH_TARGETMOVEMENTDIFFERENCIAL1 = '/tmd';
	
	local function handler(msg)
		if (msg == 'on') then
			TMD_Enable();
		elseif (msg == 'off') then
			TMD_Disable();
		elseif (msg == 'unlock') then
			df:EnableMouse(true);
			if UnitExists('target') ~= 1 then df:Show() end
			tex:SetTexture(0.0, 0.0, 1.0); tex:SetAlpha(0.5);			
		elseif (msg == 'lock') then
			df:EnableMouse(false);
			if UnitExists('target') ~= 1 then df:Hide() end
			tex:SetTexture(0.0, 0.0, 1.0); tex:SetAlpha(0.0);
		else
			local command, rest = msg:match("^(%S*)%s*(.-)$");
			if command == "fontsize" and rest ~= "" then
				fontName, fontHeight, fontFlags = fs:GetFont();
				fs:SetFont(GameFontNormal:GetFont(), rest);
			else
				Msg("Target Movement Differencial Options");
				Msg("Type:");
				Msg("  /tmd on/off");
				Msg("    to enable or disable showing of the speed frame.");
				Msg("  /tmd unlock/lock");
				Msg("    to enable or disable moving of speed frame.");
				Msg("  /tmd fontsize <size>");
				Msg("    for setting the font size");
			end
		end
	end
	
	SlashCmdList["TARGETMOVEMENTDIFFERENCIAL"] = handler;
end


function TMD_Enable()
	TargetMovementDifferencialFrame:RegisterEvent("PLAYER_TARGET_CHANGED");
	Msg('If you already have a target selected you will have to unselect it once to make the addon update again.');
end

function TMD_Disable()
	TargetMovementDifferencialFrame:UnregisterEvent("PLAYER_TARGET_CHANGED");
	TargetMovementDifferencialFrame:SetScript("OnUpdate", nil);
	df:Hide();
end

function SetTargetSpeed()
	targetSpeed = string.format("%.2f",(GetUnitSpeed('target') / 7) * 100);
	playerSpeed = string.format("%.2f",(GetUnitSpeed('player') / 7) * 100);
	
	speedDifferencial = targetSpeed - playerSpeed
	
	if (speedDifferencial == 0) then --both you and target are at same speed, yellow colour
		fs:SetTextColor(1, 0.8, 0, 1);
	elseif (speedDifferencial > 0) then --target is faster than you, red colour
		fs:SetTextColor(1, 0, 0, 1);
	elseif (speedDifferencial < 0) then --you are faster than your target, green colour
		fs:SetTextColor(0, 1, 0, 1);
	end
	fs:SetText(speedDifferencial.."%");
end

function TMD_OnEvent(event)
	if (UnitExists('target') == 1) then
		TargetMovementDifferencialFrame:SetScript("OnUpdate", TMD_OnUpdate); 
		TargetMovementDifferencialFrame.TimeSinceLastUpdate = 0;
		SetTargetSpeed();
		df:Show();
	else
		df:Hide();
		TargetMovementDifferencialFrame:SetScript("OnUpdate", nil);	
	end
end

function TMD_OnUpdate(self, elapsed)
	TargetMovementDifferencialFrame.TimeSinceLastUpdate = TargetMovementDifferencialFrame.TimeSinceLastUpdate + elapsed;	
	if (TargetMovementDifferencialFrame.TimeSinceLastUpdate > updateInterval) then
		SetTargetSpeed();
		TargetMovementDifferencialFrame.TimeSinceLastUpdate = 0;
	end
end

function Msg(text)
	DEFAULT_CHAT_FRAME:AddMessage(text);
end